%==========================================================================
%======================Funkce pro fuzi obrazu =============================
% [fused_image, filtered_image] = fuze (settings)
%==========================================================================


function [fused_image, filtered_image] = fuze (settings)

fld = dir([settings.path '\*.BMT']);

h_bar = waitbar(0, 'Fusing the image, please wait');
steps = size(fld,1);

for i = 1:steps
 pth_full = [settings.path '\' fld(i).name];

[~, img_tmp, ~, ~] = get_temperature_matrix(pth_full);

[m,n] = size (img_tmp);

%==========================================================================
%                       Rozptyl
%==========================================================================
if settings.eval_type == 1
  [k_var_matrix] = rozptyl3x3(img_tmp);
    if i == 1
     fused_image = img_tmp(1:m-2,1:n-2);
     fused_matrix = k_var_matrix;
    elseif i > 1
     [fused_image, fused_matrix] = slepeni (k_var_matrix, fused_matrix, img_tmp, fused_image);
    end 
% %==========================================================================
% %                       Gradient
% %========================================================================== 
elseif settings.eval_type == 2
  [k_eog_matrix] = gradient3x3(img_tmp);
    if i == 1
     fused_image = img_tmp(1:m-2,1:n-2);
     fused_matrix = k_eog_matrix;
    elseif i > 1
     [fused_image, fused_matrix] = slepeni (k_eog_matrix, fused_matrix, img_tmp, fused_image);
    end
% %==========================================================================
% %                       Tenengrad
% %==========================================================================
elseif settings.eval_type == 3
 [k_ten_matrix] = tenengrad3x3(img_tmp);
   if i == 1
     fused_image = img_tmp(1:m-2,1:n-2);
     fused_matrix = k_ten_matrix;
    elseif i > 1
     [fused_image, fused_matrix] = slepeni (k_ten_matrix, fused_matrix, img_tmp, fused_image);
   end
% %==========================================================================
% %                       EOL
% %==========================================================================
elseif settings.eval_type == 4
 [k_eol_matrix] = eol3x3(img_tmp);
  if i == 1
     fused_image = img_tmp(1:m-2,1:n-2);
     fused_matrix = k_eol_matrix;
  elseif i > 1
     [fused_image, fused_matrix] = slepeni (k_eol_matrix, fused_matrix, img_tmp, fused_image);
  end
%==========================================================================
%                       SML
%==========================================================================
elseif settings.eval_type == 5
[k_sml_matrix] = sml3x3(img_tmp);
  if i == 1
     fused_image = img_tmp(1:m-2,1:n-2);
     fused_matrix = k_sml_matrix;
  elseif i > 1
     [fused_image, fused_matrix] = slepeni (k_sml_matrix, fused_matrix, img_tmp, fused_image);
  end
end
%==========================================================================

h_bar = waitbar(i/steps,h_bar);
end

close(h_bar);
    
%===== Gaussian filter =======
if settings.filter == 1
        filter = fspecial('gaussian',[m n],settings.sigma);
        filtered_image = imfilter (fused_image,filter,'replicate');

%===== Wavelet filter ========
elseif settings.filter == 2
    if settings.thr_type == 1
        [filtered_image] = wavelet_filter_soft_thr(fused_image, settings.decomp, settings.wavelet, settings.thr);
    elseif settings.thr_type == 2
        [filtered_image] = wavelet_filter_hard_thr(fused_image, settings.decomp, settings.wavelet, settings.thr);
    elseif settings.thr_type == 3
        [filtered_image] = wavelet_filter_mixed_thr(fused_image, settings.decomp, settings.wavelet, settings.thr);
    end
end