%===========================================
%------------Gradient maska 3x3-------------
%===========================================
%        [k_eog]=gradient(image)

function [k_eog_matrix]=gradient3x3(image)
[m,n]= size (image); % nacteni velikosti obrazku

k_eog_matrix = zeros(m-2,n-2);  % inicializace matice pro koeficienty
%==============vypocet gradientu================
for y = 1:(n-2)                                      %
    for x = 1:(m-2)
        k_eog = 0;         % inicializace k_eog
        for z=0:1
            for w=0:1 
                f_x = image(x+1+w,y) - image(x,y);     %
                f_y = image(x,y+1+z) - image(x,y);     % viz. Bak. prace kap. 3.2.2. - Gradient
                f = f_x^2 + f_y^2;                   %
                k_eog = k_eog + f;                   %
            end
        end
        
        
        %if (k_eog > 1.5)     % pouze pro testovani, filtrace prilis nizkych hodnot pro lepsi vizualni idetifikaci hran
        k_eog_matrix (x,y) = k_eog;
        %else
        %k_eog_matrix (x,y) = 0;
        %end
    end                                              %
end                                                  %
%===============================================