function varargout = gui(varargin)
% IMAGE_FUSION MATLAB code for image_fusion.fig
%      IMAGE_FUSION, by itself, creates a new IMAGE_FUSION or raises the existing
%      singleton*.
%
%      H = IMAGE_FUSION returns the handle to a new IMAGE_FUSION or the handle to
%      the existing singleton*.
%
%      IMAGE_FUSION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in IMAGE_FUSION.M with the given input arguments.
%
%      IMAGE_FUSION('Property','Value',...) creates a new IMAGE_FUSION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the IMAGE_FUSION before image_fusion_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to image_fusion_OpeningFcn via varargin.
%
%      *See IMAGE_FUSION Options on GUIDE's Tools menu.  Choose "IMAGE_FUSION allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help image_fusion

% Last Modified by GUIDE v2.5 17-Apr-2012 21:52:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before image_fusion is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to image_fusion (see VARARGIN)

% Choose default command line output for image_fusion
handles.output = hObject;

% Update handles structure
handles.sigma = 0.8;
handles.decomp = 6;
handles.wavelet = 'sym8';
handles.thr_type = 1;
handles.eval_type = 1;
handles.filter = 1;
handles.path = [];
guidata(hObject, handles);



 set (handles.wavelet_menu, 'Enable', 'off');
 set (handles.threshold_menu, 'Enable', 'off');
 set (handles.decomp_edit, 'Enable', 'off');
 set (handles.save, 'Enable', 'off');
 guidata(hObject, handles);
 
 



% UIWAIT makes image_fusion wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in path.
function path_Callback(hObject, eventdata, handles)
% hObject    handle to path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.path = uigetdir;
guidata(hObject, handles);
if (handles.path ~= 0)
   handles.path_name = handles.path;
   guidata(hObject, handles);
   handles.path = ischar(handles.path);
   guidata(hObject, handles);
end


% --- Executes on selection change in filter_type.
function filter_type_Callback(hObject, eventdata, handles)
% hObject    handle to filter_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns filter_type contents as cell array
%        contents{get(hObject,'Value')} returns selected item from filter_type
volba = get (handles.filter_type, 'Value');
switch (volba)

    case 1
        handles.filter = 1;
        guidata(hObject, handles);
        set (handles.sigma_edit, 'Enable', 'on');
        set (handles.wavelet_menu, 'Enable', 'off');
        set (handles.threshold_menu, 'Enable', 'off');
        set (handles.decomp_edit, 'Enable', 'off');
    case 2
        handles.filter = 2;
        guidata(hObject, handles);
        set (handles.sigma_edit, 'Enable', 'off');
        set (handles.wavelet_menu, 'Enable', 'on');
        set (handles.threshold_menu, 'Enable', 'on');
        set (handles.decomp_edit, 'Enable', 'on');
end

% --- Executes during object creation, after setting all properties.
function filter_type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to filter_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sigma_edit_Callback(hObject, eventdata, handles)
% hObject    handle to sigma_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sigma_edit as text
%        str2double(get(hObject,'String')) returns contents of sigma_edit as a double
string = strrep (get (handles.sigma_edit, 'String'),',','.');
sigma = str2double(string);
if (~isnan (sigma))
    handles.sigma = sigma;
    guidata(hObject, handles);
elseif (isnan (sigma))
    set (handles.sigma_edit, 'String', 'Use numbers only');
elseif (iscell (sigma))
    set (handles.sigma_edit, 'String', 'Wrong number format');
elseif (isscalar (sigma))
    set (handles.sigma_edit, 'String', 'Wrong number format');
end

% --- Executes during object creation, after setting all properties.
function sigma_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sigma_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in wavelet_menu.
function wavelet_menu_Callback(hObject, eventdata, handles)
% hObject    handle to wavelet_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns wavelet_menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from wavelet_menu
wavelet = get (handles.wavelet_menu, 'Value');

switch (wavelet)
    
    case 1
        handles.wavelet = 'sym8';
        guidata(hObject, handles);
    case 2
        handles.wavelet = 'sym2';
        guidata(hObject, handles);
    case 3
        handles.wavelet = 'haar';
        guidata(hObject, handles);
    case 4
        handles.wavelet = 'coif1';
        guidata(hObject, handles);
    case 5
        handles.wavelet = 'coif5';
        guidata(hObject, handles);
end
        

% --- Executes during object creation, after setting all properties.
function wavelet_menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wavelet_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in threshold_menu.
function threshold_menu_Callback(hObject, eventdata, handles)
% hObject    handle to threshold_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns threshold_menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from threshold_menu
threshold = get (handles.threshold_menu, 'Value');

switch (threshold)
    case 1
        handles.thr_type = 1;
        guidata(hObject, handles);
    case 2
        handles.thr_type = 2;
        guidata(hObject, handles);
    case 3
        handles.thr_type = 3;
        guidata(hObject, handles);
end
    

% --- Executes during object creation, after setting all properties.
function threshold_menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to threshold_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in eval_menu.
function eval_menu_Callback(hObject, eventdata, handles)
% hObject    handle to eval_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns eval_menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from eval_menu
evaluation = get (handles.eval_menu, 'Value');

switch (evaluation)
    
    case 1
        handles.eval_type = 1;
        guidata(hObject, handles);
    case 2
        handles.eval_type = 2;
        guidata(hObject, handles);
    case 3
        handles.eval_type = 3;
        guidata(hObject, handles);
    case 4
        handles.eval_type = 4;
        guidata(hObject, handles);
    case 5
        handles.eval_type = 5;
        guidata(hObject, handles);
end


% --- Executes during object creation, after setting all properties.
function eval_menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to eval_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function decomp_edit_Callback(hObject, eventdata, handles)
% hObject    handle to decomp_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of decomp_edit as text
%        str2double(get(hObject,'String')) returns contents of decomp_edit as a double
string = strrep (get (handles.decomp_edit, 'String'),',','.');
numberD = str2double (string);
if (~isnan(numberD))
number = int8(numberD);
    if (isa(number, 'integer'))
        handles.decomp = number;
        guidata(hObject, handles); 
        set (handles.decomp_edit, 'String', int2str(number));
    elseif (~isa(number, 'integer'))
        set (handles.decomp_edit, 'String', 'Use interger only');    
    end
else 
    set (handles.decomp_edit, 'String', 'Worng input format');
end

% --- Executes during object creation, after setting all properties.
function decomp_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to decomp_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
    

% --- Executes on button press in fusion.
function fusion_Callback(hObject, eventdata, handles)
% hObject    handle to fusion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

error = 'U didnt choose:';
kontrola = 0;
if (isempty(handles.path) || handles.path == 0)
    error = [error ' path to image folder,'];
    kontrola = 1;
end

if (kontrola == 1)
    
   errordlg(error);
   
else
    
settings.thr = 'rigrsure';
settings.path = handles.path_name;
settings.filter = handles.filter;

if (handles.filter == 1)
    
settings.sigma = handles.sigma;

end

if (handles.filter == 2)
    
settings.thr_type = handles.thr_type;
settings.wavelet = handles.wavelet;
settings.decomp = handles.decomp;

end

settings.eval_type = handles.eval_type;
    
fld = dir([settings.path '\*.BMT']);

if(~isempty(fld))
    

    
    [fused_image, filtered_image] = fuze(settings);
    

    
    axes(handles.axes1);
    imagesc(fused_image);
    axis image;

    axes(handles.axes2);
    imagesc(filtered_image);
    axis image;
    
    handles.fused = fused_image;
    handles.filtered = filtered_image;
    guidata(hObject, handles);
    
    
    
    set (handles.save, 'Enable', 'on');
    guidata(hObject, handles);    
else
    errordlg('There is no BMT file in chosen folder!');
end

 
end  


% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fused = handles.fused;
filtered = handles.filtered;
uisave ({'fused','filtered'},'image_fusion_output');


% --------------------------------------------------------------------
