%====================================================
%
%                   Wavelet filtr
%       [sml_wavelet_image] = wavelet_filter(image)
%====================================================

function [sml_wavelet_image] = wavelet_filter(image)

wavelet = 'haar';
thr_type = 'rigrsure';
decomp_level = 3;


[C,S] = wavedec2(image,decomp_level,wavelet);

HighestDec = S(1,1)*S(1,2) + 1; % pocet aproximacnich koeficientu
LowerDec = length(C); % detailni koeficenty

detail_coefs = C(HighestDec:LowerDec);
threshold = thselect(detail_coefs,thr_type);
detail_coefs (abs(detail_coefs) < threshold) = 0;
C(HighestDec:LowerDec) = detail_coefs;

sml_wavelet_image = waverec2 (C,S,wavelet);