%====================================================
%
%                   Wavelet filtr
%       [sml_wavelet_image] = wavelet_filter(image)
%====================================================

function [wavelet_image,S] = wavelet_filter(image)

wavelet = 'sym1';
thr_type = 'rigrsure';
decomp_level = 3;


[C,S] = wavedec2(image,decomp_level,wavelet);

Area1 = S(1,1)*S(1,2) + 1; % pocet aproximacnich koeficientu
Area2 = Area1 + S(2,1)*S(2,2);
Area3 = Area2 + S(2,1)*S(2,2);
Area4 = Area3 + S(2,1)*S(2,2);
Area5 = Area4 + S(3,1)*S(3,2);
Area6 = Area5 + S(3,1)*S(3,2);
Area7 = Area6 + S(3,1)*S(3,2);
Area8 = Area7 + S(4,1)*S(4,2);
Area9 = Area8 + S(4,1)*S(4,2);

final = length(C); % detailni koeficenty
%===== Area 1 thresholding ======
coefs_Area1 = C(Area1:Area2-1);
threshold = thselect(coefs_Area1,thr_type);
coefs_Area1 (abs(coefs_Area1) < threshold) = 0;
C(Area1:Area2-1) = coefs_Area1;
%===== Area 2 thresholding ======
coefs_Area2 = C(Area2:Area3-1);
threshold = thselect(coefs_Area2,thr_type);
coefs_Area2 (abs(coefs_Area2) < threshold) = 0;
C(Area2:Area3-1) = coefs_Area2;
%===== Area 3 thresholding ======
coefs_Area3 = C(Area3:Area4-1);
threshold = thselect(coefs_Area3,thr_type);
coefs_Area3 (abs(coefs_Area3) < threshold) = 0;
C(Area3:Area4-1) = coefs_Area3;
%===== Area 4 thresholding ======
coefs_Area4 = C(Area4:Area5-1);
threshold = thselect(coefs_Area4,thr_type);
coefs_Area4 (abs(coefs_Area4) < threshold) = 0;
C(Area4:Area5-1) = coefs_Area4;
%===== Area 5 thresholding ======
coefs_Area5 = C(Area5:Area6-1);
threshold = thselect(coefs_Area5,thr_type);
coefs_Area5 (abs(coefs_Area5) < threshold) = 0;
C(Area5:Area6-1) = coefs_Area5;
%===== Area 6 thresholding ======
coefs_Area6 = C(Area6:Area7-1);
threshold = thselect(coefs_Area6,thr_type);
coefs_Area6 (abs(coefs_Area6) < threshold) = 0;
C(Area6:Area7-1) = coefs_Area6;
%===== Area 7 thresholding ======
coefs_Area7 = C(Area7:Area8-1);
threshold = thselect(coefs_Area7,thr_type);
coefs_Area7 (abs(coefs_Area7) < threshold) = 0;
C(Area7:Area8-1) = coefs_Area7;
%===== Area 8 thresholding ======
coefs_Area8 = C(Area8:Area9-1);
threshold = thselect(coefs_Area8,thr_type);
coefs_Area8 (abs(coefs_Area8) < threshold) = 0;
C(Area8:Area9-1) = coefs_Area8;
%===== Area 9 thresholding ======
coefs_Area9 = C(Area9:final);
threshold = thselect(coefs_Area9,thr_type);
coefs_Area9 (abs(coefs_Area9) < threshold) = 0;
C(Area9:final) = coefs_Area9;


wavelet_image = waverec2 (C,S,wavelet);